unit EdFieldInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FIBDatabase, pFIBDatabase, Db, FIBDataSet, pFIBDataSet, Grids,
  DBGrids, ExtCtrls, StdCtrls, DBCtrls, Buttons, Menus;

type
  TfrmFields = class(TForm)
    pFIBTransaction1: TpFIBTransaction;
    qryFL: TpFIBDataSet;
    DataSource1: TDataSource;
    sbDBGrid1: TDBGrid;
    Panel1: TPanel;
    qryTabs: TpFIBDataSet;
    DataSource2: TDataSource;
    Panel2: TPanel;
    Panel3: TPanel;
    sbDBGrid2: TDBGrid;
    EdFilter: TEdit;
    btnCopyFields: TButton;
    qryTabFields: TpFIBDataSet;
    chFilt: TCheckBox;
    qryTabsRDBRELATION_NAME: TStringField;
    qrySPs: TpFIBDataSet;
    PopupMenu1: TPopupMenu;
    miTables1: TMenuItem;
    miProcedures1: TMenuItem;
    qrySPFields: TpFIBDataSet;
    miUserForms: TMenuItem;
    qrdBuffer: TpFIBDataSet;
    procedure qryTabFieldsBeforeOpen(DataSet: TDataSet);
    procedure btnCopyFieldsClick(Sender: TObject);
    procedure chFiltClick(Sender: TObject);
    procedure qryFLFilterRecord(DataSet: TDataSet; var Accept: Boolean);
    procedure DataSource2DataChange(Sender: TObject; Field: TField);
    procedure miProcedures1Click(Sender: TObject);
    procedure qrySPFieldsBeforeOpen(DataSet: TDataSet);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure EdFilterChange(Sender: TObject);
    procedure qryFLAfterPost(DataSet: TDataSet);
    procedure qrySPsFilterRecord(DataSet: TDataSet; var Accept: Boolean);
  private
   procedure CopyTableFields;
  public
    { Public declarations }
  end;

var
  frmFields: TfrmFields;

procedure ShowFieldInfo( aDataBase:TFIBDatabase);

implementation

uses pFIBDataInfo;

{$R *.DFM}


procedure ShowFieldInfo( aDataBase:TFIBDatabase);
begin
 frmFields:= TfrmFields.Create(Application);
 with frmFields do
 try
  qrySPs.DataBase:=aDataBase;
  qrySPFields.DataBase:=aDataBase;
  qryTabFields.DataBase:=aDataBase;
  qryTabs.DataBase:=aDataBase;
  qrdBuffer.DataBase:=aDataBase;
  qryFL.DataBase:=aDataBase;
  pFIBTransaction1.DefaultDataBase:=aDataBase;
  pFIBTransaction1.StartTransaction;
  qryTabFields.Open;
  qryTabs.Open;
  qrySPs.Open;
  qryFL.Open;
  Caption:='Metadata Repositary. '+aDataBase.DBName+': FIB$FIELDS_INFO';
  ShowModal;
  ListTableInfo.ClearForDataBase(aDataBase)
 finally
  frmFields.Free
 end;
end;

procedure TfrmFields.qryTabFieldsBeforeOpen(DataSet: TDataSet);
begin
 with qryTabFields do begin
  if    DataSource2.DataSet=qryTabs then
   Params[0].asString:=qryTabs.Fields[0].asString
  else
   Params[0].asString:=qrySPs.Fields[0].asString
 end;
end;

procedure TfrmFields.CopyTableFields;
var Q:TFIBDataSet;
begin
 qryFL.DisableControls;
 if    DataSource2.DataSet=qryTabs then  Q:=qryTabFields
 else
   Q:=qrySPFields;
 with Q do try
   Close;Open; FetchAll; First;
   while not eof do begin
     if not qryFL.Locate
     ('TABLE_NAME;FIELD_NAME',
      VarArrayOf([DataSource2.DataSet.Fields[0].asString,Trim(Fields[0].asString)]),[loCaseInsensitive])
     then begin
      qryFL.Insert;
      qryFL.FieldByName('TABLE_NAME').asString:=DataSource2.DataSet.Fields[0].asString;
      qryFL.FieldByName('FIELD_NAME').asString:=Trim(Fields[0].asString);
      qryFL.Post;
     end;
     Next
   end;
 finally
  qryFL.EnableControls;
 end;
end;


procedure TfrmFields.btnCopyFieldsClick(Sender: TObject);
begin
 CopyTableFields
end;

procedure TfrmFields.chFiltClick(Sender: TObject);
begin
 qryFL.Filtered:=chFilt.Checked
end;

procedure TfrmFields.qryFLFilterRecord(DataSet: TDataSet; var Accept: Boolean);
begin
 if chFilt.Checked then
   Accept:=AnsiUpperCase(DataSet.FieldByName('TABLE_NAME').asString)=
    AnsiUpperCase(sbDBGrid2.dataSource.DataSet.Fields[0].asString)
end;

procedure TfrmFields.DataSource2DataChange(Sender: TObject; Field: TField);
begin
 if chFilt.Checked then qryFL.RefreshFilters
end;

procedure TfrmFields.miProcedures1Click(Sender: TObject);
begin
 TMenuItem(Sender).Checked:= not TMenuItem(Sender).Checked;
 if Sender=miTables1  then begin
  miProcedures1.Checked:=not miTables1.Checked;
  miUserForms.Checked  :=false;
 end
 else
 if Sender=miProcedures1  then begin

    miTables1.Checked    :=not miProcedures1.Checked;
    miUserForms.Checked  :=false;
 end
 else
 if Sender=miUserForms  then begin

    miTables1.Checked      :=not miUserForms.Checked;
    miProcedures1.Checked  :=false;
 end ;
 if miTables1.Checked then
   DataSource2.DataSet:=qryTabs
 else
 if miProcedures1.Checked then
   DataSource2.DataSet:=qrySPs
 
end;

procedure TfrmFields.qrySPFieldsBeforeOpen(DataSet: TDataSet);
begin
 with qrySPFields do begin
   Params[0].asString:=qrySPs.Fields[0].asString
 end;
end;

procedure TfrmFields.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 qryFL.Transaction.Commit;
 qryFL.Filtered:=false;
 Action:=caFree; frmFields:=nil
end;

procedure TfrmFields.EdFilterChange(Sender: TObject);
begin
 with TPFibDataSet(sbDBGrid2.DataSource.DataSet) do begin
  Filtered:=Trim(EdFilter.Text)<>'';
  RefreshFilters
 end;
end;

procedure TfrmFields.qryFLAfterPost(DataSet: TDataSet);
begin
 qryFL.Transaction.CommitRetaining;
end;

procedure TfrmFields.qrySPsFilterRecord(DataSet: TDataSet;
  var Accept: Boolean);
begin
  with DataSet do
   Accept:=Pos(Trim(EdFilter.text),
            AnsiUpperCase(FieldByName('RDB$RELATION_NAME').asString)
           )>0
end;

end.
